Skip to main content
Use the email engagement API to log and manage emails on CRM records. You can log email activities either in HubSpot or through the emails API.

Create an email engagement

To create an email engagement, make a POST request to /crm/v3/objects/emails. In the request body, add email details in a properties object. You can also add an associations object to associate your new email with an existing record (e.g., contacts, companies).

Properties

In the properties object, you can include the following fields: Learn more about batch creating email engagements by checking out the reference documentation.

Read only properties

There are also some email properties that are read only, which are automatically populated by HubSpot. The properties in the table below are all automatically populated from the hs_email_headers value.
Please note:When retrieving an email header, you may notice there are values both for From and Sender. These are often the same, but because Sender identifies what actually submitted an email, there are scenarios where the values may differ. For example, if an email is sent from an email alias, the From value will refer to the user’s actual email address, and the Sender value will refer to the email alias.

Set email headers

Since headers automatically populate the read only properties, you may want to manually set the email headers. To set the hs_email_headers value, you can use a JSON escaped string with the following data:
For example, your request to create an email may look like:

Associations

To create and associate an email with existing records, include an associations object in your request. For example, to create an email and associate it with a deal and a contact, your request body might look like the following:
In the associations object, you should include the following:

Retrieve emails

You can retrieve emails individually or in bulk. Learn more about batch retrieval by checking out the reference documentation. To retrieve an individual email by its email ID, make a GET request to /crm/v3/objects/emails/{emailId}. You can also include the following parameters in the request URL: To request a list of all of emails, make a GET request to crm/v3/objects/emails. You can include the following parameters in the request URL:

Update emails

You can update emails individually or in batches. To update an individual email by its email ID, make a PATCH request to /crm/v3/objects/emails/{emailId}. In the request body, include the email properties that you want to update. For example, your request body might look similar to the following:
HubSpot will ignore values for read-only and non-existent properties. To clear a property value, pass an empty string for the property in the request body. Learn more about batch updating by checking out the reference documentation.

Associate existing emails with records

To associate an email with records, such as a contact and its associated companies, make a PUT request to /crm/v3/objects/emails/{emailId}/associations/{toObjectType}/{toObjectId}/{associationTypeId}. The request URL contains the following fields: For example, your request URL might look similar to the following: https://api.hubspot.com/crm/v3/objects/emails/17691787884/associations/contact/104901/198

Remove an association

To remove an association between an email and a record, make a DELETE request to the same URL as above: /crm/v3/objects/emails/{emailId}/associations/{toObjectType}/{toObjectId}/{associationTypeId}

Pin an email on a record

You can pin an email on a record so it remains on the top of the record’s timeline. The email must already be associated with the record prior to pinning, and you can only pin one activity per record. To pin an email, include the email’s id in the hs_pinned_engagement_id field when creating or updating a record via the object APIs. Learn more about using the companies,contacts, deals, tickets, and custom objects APIs.

Delete emails

When you delete an email, it is permanently deleted and cannot be restored. You can delete emails individually or in batches. To delete an individual email by its email ID, make a DELETE request to /crm/v3/objects/emails/{emailId}. Learn more about deleting emails by checking out the reference documentation.
Last modified on April 13, 2026